## knxd-8255bf08b6e1a972c1489012b570bf0ff8679cb0.tar.gz

=== contrib/legacy-eibd/openwrt/Makefile ===
include $(TOPDIR)/rules.mk

PKG_NAME:=eibd
PKG_VERSION:=0.0.4.16
PKG_RELEASE:=4

PKG_SOURCE:=bcusdk_0.0.4+nmu16.tar.gz
# $(PKG_NAME)-$(PKG_VERSION).tar.gz
PKG_SOURCE_URL:=http://repo.wiregate.de/wiregate/pool/main/b/
PKG_MD5SUM:=d92f34a703d79421d90fa4e1258ca235

PKG_FIXUP:=libtool
PKG_INSTALL:=1

#PKG_BUILD_DEPENDS:=argp-standalone
#PKG_BUILD_DEPENDS:=uClibc++ libxml2 libusb argp-standalone
PKG_BUILD_DEPENDS:=uClibc++ argp-standalone

#PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(PKG_VERSION)
PKG_BUILD_DIR:=$(BUILD_DIR)/bcusdk

include $(INCLUDE_DIR)/package.mk

define Package/eibd/Default
  SECTION:=net
  CATEGORY:=Network
  TITLE:=eibd EIB/KNX 
  URL:=http://www.auto.tuwien.ac.at/~mkoegler/index.php/eibd
endef

define Package/libeibclient
  $(call Package/eibd/Default)
  DEPENDS:=+uclibcxx
  TITLE+= libeibclient
endef
define Package/eibd-server
  $(call Package/eibd/Default)
  DEPENDS:=+uclibcxx
  TITLE+= server daemon
endef
define Package/eibd-bcuaddrtab
  $(call Package/eibd/Default)
  DEPENDS:=+uclibcxx
  TITLE+= bcuaddrtab
endef
define Package/eibd-knxtool
  $(call Package/eibd/Default)
  DEPENDS:=+uclibcxx libeibclient
  TITLE+= knxtool
endef
define Package/eibd-cgi
  $(call Package/eibd/Default)
  DEPENDS:=+uclibcxx libeibclient lighttpd lighttpd-mod-setenv lighttpd-mod-cgi
  TITLE+= cgi-clients
endef

define Build/Prepare
# dirty hack for useless libtool:
	$(call Build/Prepare/Default)
endef

CONFIGURE_ARGS += \
	--enable-onlyeibd \
	--enable-eibnetiptunnel \
	--enable-eibnetip \
	--enable-eibnetipserver \
	--enable-tpuarts \
	--enable-ft12 \
	--disable-usb \
	--enable-groupcache \
	--without-libstdc 

#define Build/Compile
#	$(MAKE) -C $(PKG_BUILD_DIR) \
#		CC=$(TARGET_CC) \
#		LIBS="-L$(STAGING_DIR)/usr/lib -fno-builtin -nostdinc++ -nodefaultlibs -luClibc++ -lc -lm -lgcc -largp" \
#		CPPFLAGS="-I$(STAGING_DIR)/include -I$(STAGING_DIR)/usr/include"
#		# -I$(LINUX_DIR)/include"
#endef
MAKE_FLAGS += \
	CFLAGS="$(TARGET_CFLAGS) -Wall -D_REENTRANT" \
	LIBS="-L$(STAGING_DIR)/usr/lib -fno-builtin -nostdinc++ -nodefaultlibs -luClibc++ -lc -lm -lgcc -largp" \
	CPPFLAGS="-I$(STAGING_DIR)/include -I$(STAGING_DIR)/usr/include" \
	all

define Build/InstallDev
	$(INSTALL_DIR) $(1)/usr/include
	$(CP) $(PKG_INSTALL_DIR)/usr/include/eibclient.h $(1)/usr/include/
	$(CP) $(PKG_INSTALL_DIR)/usr/include/eibloadresult.h $(1)/usr/include/
	$(INSTALL_DIR) $(1)/usr/lib
	$(CP) $(PKG_INSTALL_DIR)/usr/lib/libeibclient.{a,so*} $(1)/usr/lib/
endef

define Package/libeibclient/install
	$(INSTALL_DIR) $(1)/usr/lib
	$(CP) $(PKG_INSTALL_DIR)/usr/lib/libeibclient.so.* $(1)/usr/lib/
endef

# FIXME: put/read eibd-config into/from UCI

define Package/eibd-server/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_BUILD_DIR)/eibd/server/eibd $(1)/usr/bin/
	$(INSTALL_DIR) $(1)/etc/init.d
	$(INSTALL_BIN) ./files/eibd.init $(1)/etc/init.d/eibd
#	$(INSTALL_DIR) $(1)/etc/default
#	$(INSTALL_BIN) ./files/eibd.default $(1)/etc/default/eibd
endef
define Package/eibd-server/postinst
#!/bin/sh
# check if we are on real system
if [ -z "$${IPKG_INSTROOT}" ]; then
        echo "Enabling rc.d symlink for eibd"
        /etc/init.d/eibd enable
        /etc/init.d/eibd start
fi
exit 0
endef

define Package/eibd-server/prerm
#!/bin/sh
# check if we are on real system
if [ -z "$${IPKG_INSTROOT}" ]; then
        echo "Removing rc.d symlink for eibd"
        /etc/init.d/eibd disable
        /etc/init.d/eibd stop
fi
exit 0
endef

define Package/eibd-bcuaddrtab/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_BUILD_DIR)/eibd/bcu/bcuaddrtab $(1)/usr/bin/
endef
define Package/eibd-cgi/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/eib*cgi $(1)/usr/bin/
	$(INSTALL_DIR) $(1)/www/cgi-bin
	ln -s /usr/bin/eibread-cgi $(1)/www/cgi-bin/r
	ln -s /usr/bin/eibwrite-cgi $(1)/www/cgi-bin/w
	$(INSTALL_BIN) ./files/cgi.l.sh $(1)/www/cgi-bin/l
endef
define Package/eibd-knxtool/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/knxtool $(1)/usr/bin/
	ln -s knxtool $(1)/usr/bin/knxread
	ln -s knxtool $(1)/usr/bin/knxreadtemp
	ln -s knxtool $(1)/usr/bin/knxwrite
	ln -s knxtool $(1)/usr/bin/knxlog
	ln -s knxtool $(1)/usr/bin/knxon
	ln -s knxtool $(1)/usr/bin/knxoff
	ln -s knxtool $(1)/usr/bin/knxif
	ln -s knxtool $(1)/usr/bin/knxswrite
	ln -s knxtool $(1)/usr/bin/knxbool
	ln -s knxtool $(1)/usr/bin/knxdimup
endef

$(eval $(call BuildPackage,libeibclient))
$(eval $(call BuildPackage,eibd-server))
$(eval $(call BuildPackage,eibd-bcuaddrtab))
$(eval $(call BuildPackage,eibd-knxtool))
$(eval $(call BuildPackage,eibd-cgi))

=== debian/changelog ===
knxd (0.12.1-3) unstable; urgency=medium

  * Merge libev branch into master.

 -- Matthias Urlichs <matthias@urlichs.de>  Tue, 17 Jan 2017 23:37:00 +0100

knxd (0.12.1-1) unstable; urgency=medium

  * Allow specifying the interface to use for multicast.

 -- Matthias Urlichs <matthias@urlichs.de>  Sat, 14 Jan 2017 17:54:17 +0100

knxd (0.12.0-2) unstable; urgency=medium

  * Check for c++11 compliance.

 -- Matthias Urlichs <matthias@urlichs.de>  Fri, 13 Jan 2017 10:11:12 +0100

knxd (0.12.0-1) unstable; urgency=medium

  * libev conversion considered complete.

 -- Matthias Urlichs <matthias@urlichs.de>  Wed, 11 Jan 2017 15:36:07 +0100

knxd (0.12.0~8-1) experimental; urgency=medium

  * ETS5 with USB host adapters in tunnel mode works.
    Router mode and TPUART: not yet.

 -- Matthias Urlichs <matthias@urlichs.de>  Tue, 10 Jan 2017 04:51:24 +0100

knxd (0.12.0~7-1) experimental; urgency=medium

  * eibnettunnel now works, with the probable exception of bus monitoring.

 -- Matthias Urlichs <matthias@urlichs.de>  Sun, 08 Jan 2017 12:06:45 +0100

knxd (0.12.0~6-1) experimental; urgency=medium

  * Merge CGI fix

 -- Matthias Urlichs <matthias@urlichs.de>  Thu, 05 Jan 2017 18:16:06 +0100

knxd (0.12.0~5-1) experimental; urgency=medium

  * group cache: fixed, tested.
    TODO: add tests to the script.
  * (v)busmonitor3: Now sending somewhat-reasonable timestamps.

 -- Matthias Urlichs <matthias@urlichs.de>  Wed, 04 Jan 2017 01:26:24 +0100

knxd (0.12.0~4-1) experimental; urgency=medium

  * Removed experimental PEI16 driver.
    Porting it to libev is nontrivial and it's not being used.
  * Ported the other drivers to libev.
  * Ditto group cache. TODO: device management code.
  * Merged master (+ stable) branch.

 -- Matthias Urlichs <matthias@urlichs.de>  Tue, 03 Jan 2017 05:38:05 +0100

knxd (0.12.0~3-1) experimental; urgency=medium

  * multicast server code works.
  * ip: and ipt: back-ends compile but have not yet been tested.
  * eibnetsearch and describe tools work.
  * Found a couple of errors; see git changelog.
  * Valgrind clean. (So far.)

 -- Matthias Urlichs <matthias@urlichs.de>  Tue, 27 Dec 2016 00:17:11 +0100

knxd (0.12.0~2-1) experimental; urgency=medium

  * connection-based server code (incomplete) and TPUART now run on libev

 -- Matthias Urlichs <matthias@urlichs.de>  Sat, 24 Dec 2016 08:28:16 +0100

knxd (0.12.0~1-1) experimental; urgency=medium

  * Layer 3 now runs on libev

 -- Matthias Urlichs <matthias@urlichs.de>  Mon, 19 Dec 2016 13:08:49 +0100

knxd (0.11.18-1) unstable; urgency=medium

  * merge CGI fix

 -- Matthias Urlichs <matthias@urlichs.de>  Thu, 05 Jan 2017 18:15:10 +0100

knxd (0.11.17-1) unstable; urgency=medium

  * Plugged a memory leak.

 -- Matthias Urlichs <matthias@urlichs.de>  Wed, 04 Jan 2017 10:16:51 +0100

knxd (0.11.16-1) unstable; urgency=medium

  * Merge from stable.

 -- Matthias Urlichs <matthias@urlichs.de>  Tue, 03 Jan 2017 05:34:28 +0100

knxd (0.11.15-1) unstable; urgency=medium

  * Merge from stable

 -- Matthias Urlichs <matthias@urlichs.de>  Sun, 18 Dec 2016 16:14:28 +0100

knxd (0.11.14-1) unstable; urgency=medium

  * Merge #171: configurable send delay
    (for those interfaces which already had a delay)

 -- Matthias Urlichs <matthias@urlichs.de>  Sun, 11 Dec 2016 23:41:48 +0100

knxd (0.11.13-1) unstable; urgency=medium

  * Re-do logging
    - numbered and named channels
    - milliseconds

 -- Matthias Urlichs <matthias@urlichs.de>  Sun, 11 Dec 2016 23:41:48 +0100

knxd (0.11.12-1) unstable; urgency=medium

  * Change tpuarts baud rate
  * Merge #174: elupus:disconnect_success

 -- Matthias Urlichs <matthias@urlichs.de>  Thu, 08 Dec 2016 19:27:15 +0100

knxd (0.11.11-1) unstable; urgency=medium

  * Add tpuarts-over-tcp driver (for CUNx, busware.de)

 -- Matthias Urlichs <matthias@urlichs.de>  Thu, 08 Dec 2016 17:22:29 +0100

knxd (0.11.11-0) unstable; urgency=medium

  * Implemented a --send-delay=X option

 -- Matthias Urlichs <matthias@urlichs.de>  Fri, 02 Dec 2016 00:44:40 +0100

knxd (0.11.10-1) unstable; urgency=medium

  * Correct invalid length of L_Busmon.ind field for busmonitor mode
  * fix server crash when there's no ACK

 -- Matthias Urlichs <matthias@urlichs.de>  Sun, 27 Nov 2016 22:07:56 +0100

knxd (0.11.9-1) unstable; urgency=medium

  * removed layer2_is_bus() call

 -- Matthias Urlichs <matthias@urlichs.de>  Sat, 19 Mar 2016 15:57:35 +0100

knxd (0.11.8-2) unstable; urgency=low

  * Merged master branch up to 0.10.13-3

 -- Matthias Urlichs <matthias@urlichs.de>  Sat, 12 Mar 2016 14:55:20 +0100

knxd (0.11.8-1) unstable; urgency=medium

  * Merged master branch up to 0.10.13-2

 -- Matthias Urlichs <matthias@urlichs.de>  Fri, 11 Mar 2016 16:40:16 +0100

knxd (0.11.7-2) unstable; urgency=medium

  * Merged master branch up to 0.10.12-1

 -- Matthias Urlichs <matthias@urlichs.de>  Sat, 23 Jan 2016 15:52:06 +0100

knxd (0.11.6-1) unstable; urgency=medium

  * Merged master branch up to 0.10.11-1

 -- Matthias Urlichs <matthias@urlichs.de>  Fri, 08 Jan 2016 17:57:49 +0100

knxd (0.11.5-1) unstable; urgency=medium

  * Merged master branch up to 0.10.10-1

 -- Matthias Urlichs <matthias@urlichs.de>  Wed, 18 Nov 2015 13:40:53 +0100

knxd (0.11.4-2) unstable; urgency=medium

  * Merged master branch up to 0.10.9-3

 -- Matthias Urlichs <matthias@urlichs.de>  Mon, 12 Oct 2015 16:14:16 +0200

knxd (0.11.4-1) unstable; urgency=medium

  * Merged master branch up to 0.10.9-2

 -- Matthias Urlichs <matthias@urlichs.de>  Sun, 20 Sep 2015 16:14:50 +0200

knxd (0.11.3-1) unstable; urgency=medium

  * Default Unix socket changed to /run/knx

 -- Matthias Urlichs <matthias@urlichs.de>  Thu, 17 Sep 2015 02:22:27 +0200

knxd (0.11.2-4) unstable; urgency=medium

  * Merged

 -- Matthias Urlichs <matthias@urlichs.de>  Thu, 17 Sep 2015 02:15:36 +0200

knxd (0.11.2-3) unstable; urgency=medium

  * Merged master branch

 -- Matthias Urlichs <matthias@urlichs.de>  Thu, 10 Sep 2015 14:08:39 +0200



=== debian/control ===
Source: knxd
Section: net
Priority: optional
Maintainer: Timo <knxd@timo-wingender.de>
Build-Depends: debhelper (>= 7.0.0),
  autotools-dev, autoconf, automake, libtool,
  libusb-1.0-0-dev (>= 1.0.9),
  pkg-config,
  libsystemd-dev (>= 228) | libsystemd-daemon-dev (>= 200) | base-files (<< 8),
  debianutils,
  dh-systemd | base-files (<< 8),
  libev-dev,
Build-Conflicts: libsystemd-daemon-dev (<< 200)
Standards-Version: 3.9.4
Homepage: https://github.com/Makki1/knxd
Vcs-Git: https://github.com/Makki1/knxd.git
#Vcs-Browser: 

Package: knxd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libusb-1.0-0 (>= 1.0.10), lsb-base
Replaces: eibd, eibd-server
Conflicts: eibd, eibd-server
Description: A daemon to access the KNX bus
 KNX is a standard prototocol for home and buildin control.
 .
 This package contains the daemon to access the physical bus,
 monitor and forward messages, etc.

Package: knxd-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libusb-1.0-0
Recommends: knxd
Replaces: eibd-clients, eibd-server, libeibclient0
Conflicts: eibd-clients, eibd-server, libeibclient0
Description: Tools to use knxd
 KNX is a standard prototocol for home and buildin control.
 .
 This package contains command-line tools to communicate with the KNX
 daemon.

Package: knxd-dev
Architecture: all
Description: Development files for knxd
 KNX is a standard prototocol for home and buildin control.
 .
 These are the development files for knxd clients.

Package: knxd-examples
Architecture: any
Recommends: knxd-tools
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: documentation and examples for knxd
 KNX is a standard prototocol for home and buildin control.
 .
 These are example programs for knxd.

=== contrib/legacy-eibd/debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_CONFIGURE_EXTRA_FLAGS := \
	--enable-ft12 \
	--enable-tpuarts \
	--enable-eibnetip \
	--enable-eibnetipserver \
	--enable-groupcache \
	--enable-usb \
	--enable-eibnetiptunnel \
	--enable-onlyeibd

DEB_DH_STRIP_ARGS := -Xusr/lib/bcusdk/lib -Xusr/lib64/bcusdk/lib --dbg-package=eibd-dbg
DEB_DH_INSTALL_SOURCEDIR := debian/tmp
DEB_INSTALL_DOCS_ALL := README

clean::
	find -type l -exec rm {} \;
	autoreconf -i

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=-format
export DEB_BUILD_HARDENING_FORMAT=0


# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh $@ 

override_dh_clean:
	dh_clean
	rm -f debian/knxd.install

override_dh_auto_configure: configure install-sh
	dh_auto_configure -- --enable-usb --enable-groupcache --enable-ft12 --enable-ncn5120 --enable-tpuarts --enable-tpuarts-tcp --enable-dummy --libexecdir=/usr/lib --enable-dependency-tracking --enable-silent-rules CFLAGS=-g\ -O0 CXXFLAGS=-g\ -O0

configure install-sh: configure.ac
	sh bootstrap.sh

override_dh_install: debian/knxd.install debian/knxd.socket debian/knxd.service
	dh_install
	dh_systemd_enable || true
	dh_systemd_start || true

override_dh_installudev: debian/knxd.udev
	# install the udev file to /etc since it needs to be modified
	mkdir -p debian/knxd/usr/share/doc/knxd/examples
	install debian/knxd.udev debian/knxd/usr/share/doc/knxd/examples/70-knxd.rules.sample

debian/knxd.install: debian/knxd.install.in
	cp $^ $@
	grep -qs 'HAVE_SYSTEMD_TRUE.*#' config.status || cat $@.systemd >> $@

debian/knxd.socket: systemd/knxd.socket
	test -e $^ && cp $^ $@
debian/knxd.service: systemd/knxd.service
	test -e $^ && cp $^ $@
systemd/knxd.socket systemd/knxd.service:
	$(MAKE) -C systemd

override_dh_auto_test:
	bash tools/test.sh
